clang 10.0.0git

Classes | Public Member Functions | List of all members
clang::threadSafety::BeforeSet Class Reference

## Public Member Functions
| BeforeSet ()=default
BeforeInfo * | insertAttrExprs (const ValueDecl *Vd, ThreadSafetyAnalyzer &Analyzer)
| Process acquired_before and acquired_after attributes on Vd. More...
BeforeInfo * | getBeforeInfoForDecl (const ValueDecl *Vd, ThreadSafetyAnalyzer &Analyzer)
void | checkBeforeAfter (const ValueDecl *Vd, const FactSet &FSet, ThreadSafetyAnalyzer &Analyzer, SourceLocation Loc, StringRef CapKind)
| Return true if any mutexes in FSet are in the acquired_before set of Vd. More...

## Detailed Description

Definition at line 275 of file ThreadSafety.cpp.

## Constructor & Destructor Documentation

## ◆ BeforeSet()

clang::threadSafety::BeforeSet::BeforeSet | ( |  | ) |
| default

## Member Function Documentation

## ◆ checkBeforeAfter()

void BeforeSet::checkBeforeAfter | ( | const ValueDecl * | Vd,
|  | const FactSet & | FSet,
|  | ThreadSafetyAnalyzer & | Analyzer,
|  | SourceLocation | Loc,
|  | StringRef | CapKind
| ) |  |

Return true if any mutexes in FSet are in the acquired_before set of Vd.

Definition at line 1138 of file ThreadSafety.cpp.

References clang::NamedDecl::getName(), and clang::ast_matchers::traverse().

## ◆ getBeforeInfoForDecl()

BeforeSet::BeforeInfo * BeforeSet::getBeforeInfoForDecl | ( | const ValueDecl * | Vd,
|  | ThreadSafetyAnalyzer & | Analyzer
| ) |  |

Definition at line 1125 of file ThreadSafety.cpp.

## ◆ insertAttrExprs()

BeforeSet::BeforeInfo * BeforeSet::insertAttrExprs | ( | const ValueDecl * | Vd,
|  | ThreadSafetyAnalyzer & | Analyzer
| ) |  |

Process acquired_before and acquired_after attributes on Vd.

Definition at line 1070 of file ThreadSafety.cpp.

References clang::Decl::attrs(), and clang::threadSafety::CapabilityExpr::valueDecl().

The documentation for this class was generated from the following file:

- lib/Analysis/ThreadSafety.cpp